Subject: new Gnu Ada compiler (1.64) available
From: [email-masked] (Rolf EBERT)
Date: 20 Dec 1993 01:56:23 +0200
Newsgroups: comp.os.linux.announce

Here comes the new Gnu Ada compiler -- called GNAT -- for Linux in its
newly updated form as of December 10th (1.64 Linux pl. 1). I have
uploaded gnat-1.64-l1.tar.gz into the incoming directories of SunSite,
tsx-11, and Nic. From SunSite and Nic you can get it right now. Expect
some time until the maintainers move it to the following directories:

sunsite.unc.edu:/pub/Linux/development/ada/gnat-1.64.l1.tar.gz
nic.funet.fi:/pub/OS/Linux/util/languages/gnat-1.64.l1.tar.gz
tsx-11.mit.edu:/pub/linux/packages/Ada/gnat-1.64.l1.tar.gz

It replaces the previous version gnat-931110.tar.gz

The compiler still is under development, so expect some bugs. A more or
less final version is announced for the end of the year.

The GNAT project will implement the full Ada9X language which has full
support of Object Oriented Programming (using a slightly different
approach than C++, see the paper intro-9x.txt), has already working
Generics (aka templates), exception handling, and a full tasking support
within the language itself (the runtime support is not yet ready)

There still are some problems in the current version (and in my Linux
port). If you find errors in the already implemented parts (see below),
please write to [email-masked]. If you think it is Linux
related, please tell me ([email-masked]). I have tested the compiler on
the examples and of course on itself. The executable that you find in
this distribution has compiled itself. There is a bug in the Linux
assembler 'as'. You need a patched version, if you want to bootstrap
gnat1 yourself. Drop me a note ([email-masked]), and I will mail it to
you.

This distribution mainly contains two files:

./usr/lib/gcc-lib/i486-linux/2.5.7/gnat1
./usr/bin/gnatbind

They have been compiled with gcc-2.5.7 (C) and gnat-1.64 (Ada). They are
dynamically linked with libc-4.4.4.

You find some documentation about using GNAT and Ada9x in
./usr/src/gnat

Since version 2.5.0, Ada support already is included in the main
distribution of GCC. So we don't need a special driver program anymore
(/usr/bin/gcc). This means that you must have installed a version of GCC
2.5.X. 

If you use gcc 2.4.5, you need a patched driver program /usr/bin/gcc. 
It can be found in the same directory where you get the Linux GNAT
distribution.  Simply copy the gnat1 executable into the needed gcc
directory:

% mv /usr/lib/gcc-lib/i486-linux/2.5.7/gnat1 /usr/lib/gcc-lib/i486-linux/2.4.5/gnat1
% cd /
% zcat gcc-drv-2.4.5.tar.gz | tar xf - 

Perhaps it is a good idea to get the latest Ada9X reference manual from:

ajpo.sei.cmu.edu:/public/ada9x/rm9x/v4.0

It might look a bit thick, but there are a lot of instructive examples
and you better understand the list of supported and unsupported features
of the current release.

Two working examples are in 

./usr/src/gnat/examples/hello 
./usr/src/gnat/examples/instruments

The first few packages of the runtime library are in 

./usr/src/gnat/rtl

I'll build a libada.a as soon as the include files don't have to be in
the current directory (a momentary limitation of GNAT).

Please read and gnat-intro (a kind of user guide for GNU-Ada)

BUGS

I think I have solved the "setjmp" problem. Gcc (gnat1) now reports
syntax errors correctly. If you have problems using gnat please tell me
([email-masked]) first. I will check on a Sparc Station if it is a Linux
port problem or a bug in GNAT.

If you have general questions concerning Ada, please read comp.lang.ada
and the useful FAQ. A lot of Ada information can be found at
wuarchive.wustl.edu:/languages/ada

-----------------------------------------------------------------------------
Rolf Ebert     Groupe Informatique et Systemes Energetiques     GISE EMP-ENPC
Tel: +33 1 43044098 app 3475 FAX: +33 1 43046364            La Courtine Cedex
Internet: [email-masked]                                F-93167 Noisy le Grand
-----------------------------------------------------------------------------

--
Mail submissions for comp.os.linux.announce to: [email-masked]
PLEASE remember Keywords: and a short description of the software.